do -- Functions I always use, probably not in a reader's interests
	function table.contains(list, element)
		for i=1, #list
			do if list[i] == element
				then return i
			end
		end
		return false
	end
	function isInteger(x)
		return x == math.floor(x)
	end
	function CardinalToCoord(dir, multiplier)
		if dir == "up"
			then return 0, -(multiplier)
		elseif dir == "down"
			then return 0, multiplier
		elseif dir == "left"
			then return -(mulitplier), 0
		elseif dir == "right"
			then return multiplier, 0
		end
	end
	function string:split(delimiter) --Not by me
		local result = {}
		local from  = 1
		local delim_from, delim_to = string.find( self, delimiter, from  )
		while delim_from do
			table.insert( result, string.sub( self, from , delim_from-1 ) )
			from = delim_to + 1
			delim_from, delim_to = string.find( self, delimiter, from  )
		end
		table.insert( result, string.sub( self, from  ) )
		return result
	end
	function mouseon(x, y, w, h)
		return collision(love.mouse.getX(), love.mouse.getY(), 1, 1, x, y, w, h)
	end
	function collision(ax1,ay1,aw,ah, bx1,by1,bw,bh) ---Not by me
		local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
		return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
	end
end -- End of basic functions
function love.load()
	love.graphics.setBackgroundColor(255, 255, 155)
	do --image loading
		images = {}
		images.grid = love.graphics.newImage("graphics/grid.png")
		images.dark = love.graphics.newImage("graphics/dark.png")
		images.light = love.graphics.newImage("graphics/light.png")
	end
	do --grid indexing
		grid = {}
		grid.walls = {}
		for x = 1, 16
			do grid.walls[x] = {}
			for y = 0.5, 16.5
				do grid.walls[x][y] = false
			end
		end
		for x = 0.5, 16.5
			do grid.walls[x] = {}
			for y = 1, 16
				do grid.walls[x][y] = false
			end
		end
	end
	for x = 1, 16
		do grid[x] = {}
		for y = 1, 16
			do grid[x][y] = {}
			grid[x][y].space = false
			grid[x][y].reactor = false
		end
	end
	loadLevel("1.txt")
	motion = {}
	motion.moving = false
	motion.timer = 0
	dirNames = {"up", "down", "left", "right"}
end
function love.draw()
	love.graphics.draw(images.grid, 112, 12)
	for x = 1, 16
		do for y = 1, 16
			do if grid[x][y].reactor
				then if grid[x][y].reactor.isMoving
					then love.graphics.draw(images[grid[x][y].reactor.type], 112+(36*(x-1))+motion.x, 12+(36*(y-1))+motion.y)
				else
					love.graphics.draw(images[grid[x][y].reactor.type], 112+(36*(x-1)), 12+(36*(y-1)))
				end
			end
		end
	end
	for x = 1, 16
		do for y = 0.5, 16.5
			do if grid.walls[x][y]
				then love.graphics.rectangle("fill", 111+(36*(x-1)), 11+(36*(y-0.5)), 16, 2)
			end
		end
	end
	for x = 0.5, 16.5
		do for y = 1, 16
			do if grid.walls[x][y]
				then love.graphics.rectangle("fill", 111+(36*(x-0.5)), 11+(36*(y-1)), 2, 16)
			end
		end
	end
end
function love.update(dt)
	if motion.moving
		then motion.timer = motion.timer + (36*dt)
		if math.floor(motion.timer) < 36
			then motion.x, motion.y = CardinalToCoord(motion.dir, math.floor(motion.timer))
		else
			motion.x, motion.y = 0, 0
			local newCoords = {}
			local x2, y2 = CardinalToCoord(motion.dir, 1)
			for x = 1, 16
				do for y = 1, 16
					do grid[x][y].reactor.isMoving = false
					newCoords[x+x2][y+y2] = grid[x][y].reactor
					grid[x][y].reactor = false
				end
			end
			for x = 1, 16
				do for y = 1, 16
					do grid[x][y].reactor = newCoords[x][y]
					if grid[x][y].space == false
						then grid[x][y].reactor = false -- FUTURE CONTENT: if reactor is cloud reactor, restart level
					end
				end
			end
			-- FUTURE CONTENT: for x = 1, 16
				-- do for y = 1, 16
					---do if grid[x][y].isFrozen or grid[x][y].reactor.isFrozen
						-- then tryMove(x, y, motion.dir)
					-- end
				-- end
			-- end
			motion.moving = false
		end
	end
end
function loadLevel(file)
	local leveldata = love.filesystem.read("levels/" .. file)
	leveldata = leveldata:split("|")
	for i = 1, 256
		do leveldata[i] = leveldata[i]:split(",")
	end
	for i = 1, 256
		do local y , x = math.modf(i/16)
		if x == 0
			then x = 16
		end
		y = y+1
		grid[x][y].space = (leveldata[i][1] == "1")
		if leveldata[i][2] == "0"
			then grid[x][y].reactor = false
		else
			grid[x][y].reactor.type = leveldata[i][2]
		end
	end
	for i = 1, 272
		do local y, x = math.modf(i/16)
		if x == 0
			then x = 16
		end
		y = y+1
		grid.walls[x][y-0.5] = (leveldata[256+i] == "1")
	end
	for i = 1, 272
		do local y, x = math.modf(i/16)
		if x == 0
			then x = 16
		end
		y = y+1
		grid.walls[x-0.5][y] = (leveldata[528+i] == "1")
	end
end
function tryMove(x, y, dir)
	local x2, y2 = CardinalToCoord(dir, 0.5)
	if grid.walls[x+x2][y+y2]
		then grid[x][y].reactor.isMoving = false
		return false
	end
	x2, y2 = CardinalToCoord(dir, 1)
	if grid[x+x2][y+y2].reactor
		then if grid[x+x2][y+y2].reactor.isMoving
			then grid[x][y].reactor.isMoving = true
			return true
		elseif grid[x+(2*x2)][y+(2*y2)].reactor
			then grid[x][y].reactor.isMoving = grid[x+(2*x2)][y+(2*y2)].reactor.isMoving
		else 
			grid[x][y].reactor.isMoving = tryMove(x+x2, y+y2, dir)
		end
	else
		grid[x][y].reactor.isMoving = true
		return true
	end
end